---
title: object-fit
slug: Web/CSS/object-fit
tags:
  - CSS
  - CSS Images
  - CSS Property
  - Layout
  - Reference
  - css layout
  - object-fit
  - 'recipe:css-property'
  - size
---
<div>{{CSSRef}}</div>

<p>The <strong><code>object-fit</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets how the content of a <a href="/en-US/docs/Web/CSS/Replaced_element">replaced element</a>, such as an {{HTMLElement("img")}} or {{HTMLElement("video")}}, should be resized to fit its container.</p>

<p>You can alter the alignment of the replaced element's content object within the element's box using the {{cssxref("object-position")}} property.</p>

<div>{{EmbedInteractiveExample("pages/css/object-fit.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<p>The <code>object-fit</code> property is specified as a single keyword chosen from the list of values below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>contain</code></dt>
 <dd>The replaced content is scaled to maintain its aspect ratio while fitting within the element’s content box. The entire object is made to fill the box, while preserving its aspect ratio, so the object will be <a href="https://en.wikipedia.org/wiki/Letterboxing_(filming)">"letterboxed"</a> if its aspect ratio does not match the aspect ratio of the box.</dd>
 <dt><code>cover</code></dt>
 <dd>The replaced content is sized to maintain its aspect ratio while filling the element’s entire content box. If the object's aspect ratio does not match the aspect ratio of its box, then the object will be clipped to fit.</dd>
 <dt><code>fill</code></dt>
 <dd>The replaced content is sized to fill the element’s content box. The entire object will completely fill the box. If the object's aspect ratio does not match the aspect ratio of its box, then the object will be stretched to fit.</dd>
 <dt><code>none</code></dt>
 <dd>The replaced content is not resized.</dd>
 <dt><code>scale-down</code></dt>
 <dd>The content is sized as if <code>none</code> or <code>contain</code> were specified, whichever would result in a smaller concrete object size.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_object-fit_for_an_image">Setting object-fit for an image</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;section&gt;
  &lt;h2&gt;object-fit: fill&lt;/h2&gt;
  &lt;img class="fill" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;img class="fill narrow" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;h2&gt;object-fit: contain&lt;/h2&gt;
  &lt;img class="contain" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;img class="contain narrow" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;h2&gt;object-fit: cover&lt;/h2&gt;
  &lt;img class="cover" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;img class="cover narrow" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;h2&gt;object-fit: none&lt;/h2&gt;
  &lt;img class="none" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;img class="none narrow" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;h2&gt;object-fit: scale-down&lt;/h2&gt;
  &lt;img class="scale-down" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;

  &lt;img class="scale-down narrow" src="https://mdn.mozillademos.org/files/6457/mdn_logo_only_color.png" alt="MDN Logo"&gt;
&lt;/section&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">h2 {
  font-family: Courier New, monospace;
  font-size: 1em;
  margin: 1em 0 0.3em;
}

div {
  display: flex;
  flex-direction: column;
  flex-wrap: wrap;
  align-items: flex-start;
  height: 940px;
}

img {
  width: 150px;
  height: 100px;
  border: 1px solid #000;
  margin: 10px 0;
}

.narrow {
  width: 100px;
  height: 150px;
}

.fill {
  object-fit: fill;
}

.contain {
  object-fit: contain;
}

.cover {
  object-fit: cover;
}

.none {
  object-fit: none;
}

.scale-down {
  object-fit: scale-down;
}
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Setting_object-fit_for_an_image', 500, 1100) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Images', '#the-object-fit', 'object-fit')}}</td>
   <td>{{Spec2('CSS4 Images')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Images', '#the-object-fit', 'object-fit')}}</td>
   <td>{{Spec2('CSS3 Images')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.object-fit")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Other image-related CSS properties: {{cssxref("object-position")}}, {{cssxref("image-orientation")}}, {{cssxref("image-rendering")}}, {{cssxref("image-resolution")}}.</li>
 <li>{{cssxref("background-size")}}</li>
</ul>
